class Singleton(object):
	"""
	Singleton design pattern.
	"""
	_instance = None
	@classmethod
	def get_instance(cls):
		if cls._instance is None:
			_class = cls._singleton_get_class()
			cls._instance = _class()
		return cls._instance

	@classmethod
	def _singleton_get_class(cls):
		return cls

	def __init__(self):
		if type(self) is Singleton:
			raise NotImplementedError()

class Flyweight(object):
	"""
	Flyweight design pattern.
	"""
	_instances = {}
	@classmethod
	def get_instance(cls, name=None):
		if not name in cls._instances:
			instance = cls(name)
			cls._instances[name] = instance
		return cls._instances[name]

	def __init__(self):
		super(Flyweight, self).__init__()
		if type(self) is Flyweight:
			raise NotImplementedError()
