# base exception classes, do not use directly

class SandglassException(Exception):
	pass

class SandglassExceptionWithMessage(SandglassException):
	def __init__(self, message):
		self._message = message

	def __str__(self):
		return self._message

# exceptions which can be raise

class RepositoryInitialization(SandglassExceptionWithMessage):
	pass

class RepositoryFormat(SandglassExceptionWithMessage):
	pass

class UnexpectedResult(SandglassExceptionWithMessage):
	pass

class InvalidRevision(SandglassExceptionWithMessage):
	pass

class DistributionNotSupported(SandglassException):
	def __str__(self):
		return "Sandglass does not support your distribution."

builtin_OIError = IOError
class IOError(builtin_OIError, SandglassException):
	pass

class InvalidOperation(SandglassException):
	pass

class CommandFailed(SandglassException):
	pass
