#!/usr/bin/python2.7

import sys
import sandglass

print_debug_enabled = False
def print_debug(msg):
	global print_debug_enabled
	if not print_debug_enabled:
		return

	print >>sys.stderr, msg

def run_autocommit():
	global sgl
	if not sgl.is_initialized():
		print_debug("Repository not initialized.")
		return

	autocommit= sandglass.autocommit.get_instance()
	if not autocommit.is_enabled() or autocommit.is_stalled_all():
		print_debug("Autocommiting disabled.")
		return

	distinfo = sandglass.distinfo.get_instance()
	changed = sgl.changed().by_package()
	for package in changed:
		if autocommit.is_stalled(package):
			print_debug("Package %s stalled." % package)
			continue
		package_files = distinfo.package_files(package)

		print_debug("Performing the commit for @%s." %package)
		sgl.add(package_files)
		sgl.commit("autocommit @%s" % package)

def run_sync():
	global sgl
	if len(sgl.remote()) == 0:
		print_debug("No remotes set. Will not sync.")
		return
	sgl.sync()

if __name__ == "__main__":
	print_debug_enabled = "--test" in sys.argv[1:]

	sgl = sandglass.Sandglass()

	try:
		run_autocommit()
		run_sync()
	except Exception as e:
		# logging would be useful
		print_debug("ERROR: %s" % e)
